
function ButtonManager()
{
}
ButtonManager.prototype.getWrapperReference= function(btnWrapperObj)
{
var ob= btnWrapperObj;
var className= ob.className;
while (className.indexOf("bWrapper")==-1)
{
ob= ob.parentNode;
className= ob.className;
}
return ob;
}
ButtonManager.prototype.hpButtonOver= function(btnWrapperObj)
{
if (!this.getButtonChild(btnWrapperObj).disabled)
{
var ob= this.getWrapperReference(btnWrapperObj);
if (ob.className.indexOf("bEmphasized")!=-1)
{
ob.className= "bWrapperOver bEmphasized";
}
else
{
ob.className= "bWrapperOver";
}
}
}
ButtonManager.prototype.hpButtonUp= function(btnWrapperObj)
{
if (!this.getButtonChild(btnWrapperObj).disabled)
{
var ob= this.getWrapperReference(btnWrapperObj);
if (ob.className.indexOf("bEmphasized")!=-1)
{
ob.className= "bWrapperUp bEmphasized";
}
else
{
ob.className= "bWrapperUp";
}
}
}
ButtonManager.prototype.hpButtonDown= function(btnWrapperObj)
{
var ob= this.getWrapperReference(btnWrapperObj);
var childButton= this.getButtonChild(btnWrapperObj);
if (!childButton.disabled)
{
if (ob.className.indexOf("bEmphasized")!=-1)
{
ob.className= "bWrapperDown bEmphasized";
}
else
{
ob.className= "bWrapperDown";
}
childButton.focus();
}
}
ButtonManager.prototype.disableButton= function(btnObj)
{
btnObj.disabled= true;
var wrapper= this.getWrapperReference(btnObj);
var wrapper= this.getWrapperReference(btnObj);
wrapper.onmousedown= null;
wrapper.onmouseup=  null;
wrapper.onmouseover=  null;
wrapper.onmouseout=  null;
if (wrapper.className.indexOf("bEmphasized")!=-1)
{
wrapper.className= "bWrapperDisabled bEmphasized";
}
else
{
wrapper.className= "bWrapperDisabled";
}
}
ButtonManager.prototype.enableButton= function(btnObj)
{
btnObj.disabled= false;
var wrapper= this.getWrapperReference(btnObj);
if (wrapper.className.indexOf("bEmphasized")!=-1)
{
wrapper.className= "bWrapperUp bEmphasized";
}
else
{
wrapper.className= "bWrapperUp";
}
var wrapper= this.getWrapperReference(btnObj);
wrapper.onmousedown= function()
{ourButtonManager.hpButtonDown(this);}
wrapper.onmouseup= function()
{ourButtonManager.hpButtonOver(this);}
wrapper.onmouseover= function()
{ourButtonManager.hpButtonOver(this);}
wrapper.onmouseout= function()
{ourButtonManager.hpButtonUp(this);}
}
ButtonManager.prototype.disableButtonById= function(btnId)
{
var btnObj= document.getElementById(btnId);
this.disableButton(btnObj);
}
ButtonManager.prototype.enableButtonById= function(btnId)
{
var btnObj= document.getElementById(btnId);
this.enableButton(btnObj);
}
ButtonManager.prototype.getButtonChild= function(divObj)
{
var obj= divObj;
while ((obj.childNodes[0]!=null) && ((obj.tagName!="BUTTON") && (obj.tagName!="INPUT")) &&  (obj.tagName!="A") && (obj.tagName!="SUBMIT") )
{
var isFound= false;
for(var i=0; i<obj.childNodes.length && !isFound; ++i)
{
if(obj.childNodes[i].nodeType==1)
{
obj= obj.childNodes[i];
isFound= true;
}
} 
}
return obj;
}
ButtonManager.prototype.init= function() 
{
var divs= document.getElementsByTagName("DIV");
for (var i=0;i<divs.length;i++) 
{ 
if (divs[i].className.indexOf("bWrapper")!=-1) 
{ 
var button= this.getButtonChild(divs[i]);
var lookingForVerticalButtonSet= divs[i];
while ((lookingForVerticalButtonSet) && (lookingForVerticalButtonSet.className!="verticalButtonSet")) 
{
lookingForVerticalButtonSet= lookingForVerticalButtonSet.parentNode;
}
if (lookingForVerticalButtonSet) 
{
button.style.width= "100%";
}
else if ((!button.getAttribute("disableminimumwidth")) && (button.className.indexOf("shrinkWrapButton")==-1))
{ 
if (button.className.indexOf("hpButtonSmall")!=-1) 
{ 
if (button.offsetWidth < 47) button.style.width= "47px";
}
else if (button.className.indexOf("hpButtonVerySmall")!=-1) 
{
}
else if (button.offsetWidth < 83) button.style.width= "83px";
}
if (!button.disabled) 
{
divs[i].onmousedown= function()
{ourButtonManager.hpButtonDown(this);}
divs[i].onmouseup= function()
{ourButtonManager.hpButtonOver(this);}
divs[i].onmouseover= function()
{ourButtonManager.hpButtonOver(this);}
divs[i].onmouseout= function()
{ourButtonManager.hpButtonUp(this);}
if (button.onclick)
{ 
eval("divs[i].onclick= function(){var hardCodedFunction = "+button.onclick+" ;return hardCodedFunction();};");
button.onclick= function(event){};
}
var buttonChildren= divs[i].getElementsByTagName("BUTTON");
var inputChildren= divs[i].getElementsByTagName("INPUT");
for (var j=0;j<buttonChildren.length;j++)
{ 
buttonChildren[j].onfocus= function()
{ourButtonManager.hpButtonDown(this);}
buttonChildren[j].onblur= function()
{ourButtonManager.hpButtonUp(this);}
}
for (var j=0;j<inputChildren.length;j++)
{
inputChildren[j].onfocus= function()
{ourButtonManager.hpButtonDown(this);}
inputChildren[j].onblur= function()
{ourButtonManager.hpButtonUp(this);}
}
}
else
{
if (divs[i].className.indexOf("bEmphasized")!=-1)
{
divs[i].className= "bWrapperDisabled bEmphasized";
}
else
{
divs[i].className= "bWrapperDisabled";
}
}
}
}
}

function CStoragePresenter()
{
var m_hintPresenter= new CHintPresenter();
var m_BYTES_PER_BLOCK= 512;
var m_MKT_BYTES_PER_MB= 1000000;
var m_MKT_MB_PER_GB= 1000;
var m_BLOCKS_PER_KB= 2;
var m_BLOCKS_PER_MB= 2048;
var m_BLOCKS_PER_GB= 2097152;
var m_BLOCKS_PER_TB= 2147483648;
var m_MB_PER_TB= 1048576;
var m_MB_PER_GB= 1024;
var m_KB_PER_MB= 1024;
this.getDisplayName= function(attrName, attrValue)
{
var name= "";
if ((attrName== ATTR_NAME_UNIQUE_ID) && attrValue)
{
var d=g_model.getDevice(attrValue);
if (d)
{
name= this.LoadString(d.getAttribute(ATTR_NAME_TYPE));
}
}
else
{
name= this.LoadString(attrName);
if(g_model.deviceRoot().getAttribute(GUI_NAME_MOCKUP_DATA)==GUI_VALUE_TRUE)
{
name= name.replace("_", " ");
}
}
return name;
}
this.getDisplayValue= function(attrName, attrValue)
{
var value;
if ((attrName== ATTR_NAME_UNIQUE_ID) && attrValue)
{
var d=g_model.getDevice(attrValue);
if (d)
{
value= d.getAttribute(GUI_NAME_LABEL);
}
}
else if( (attrName== ATTR_NAME_BOX_NAME)||
(attrName== ATTR_NAME_SECTORS) ){ value = attrValue;}
else if( (attrName== ATTR_NAME_ARRAY_NUMBER)){ value = this.intToAlpha(attrValue);}
else if( (attrName== ATTR_NAME_DRIVE_NUMBER) || 
(attrName== ATTR_NAME_IO_SLOT) ||
(attrName== ATTR_NAME_SCSI_BUS) ||
(attrName== ATTR_NAME_BUS)){ value = this.increment(attrValue);}
else if( (attrName== ATTR_NAME_USEABLE_BLOCKS) ){ value = this.convertStr(attrValue, STR_BLOCKS, STR_MB);}
else if( (attrName== ATTR_NAME_FREE_BLOCKS)){ value = this.convertStr(attrValue, STR_BLOCKS, STR_MB);}
else if( (attrName== ATTR_NAME_TOTAL_BLOCKS)){ value = this.BlocksToMarketingPhysicalSizeStr(attrValue);}
else if( (attrName== ATTR_NAME_STRIPE_SIZE)){ value = this.convertStr(attrValue, STR_BLOCKS, STR_KB);}
else if( (attrName== ATTR_NAME_CACHE_SIZE_READ) ||
(attrName== ATTR_NAME_CACHE_SIZE_WRITE) ||
(attrName== ATTR_NAME_CACHE_SIZE_TOTAL) ||
(attrName== ATTR_NAME_CACHE_SIZE_TOTAL_BBBWC)){ value = this.convertStr(attrValue, STR_BLOCKS, STR_MB);}
else if( (attrName== ATTR_NAME_ERASE_PERCENT_COMPLETE) ||
(attrName== ATTR_NAME_EXPAND_PERCENT_COMPLETE)||
(attrName== ATTR_NAME_REBUILD_PERCENT_COMPLETE) ){ value = this.toPercent(attrValue, 0);}
else if( (attrName== ATTR_NAME_ROTATIONAL_SPEED) ){ value = attrValue/1000 + "K";}
else
{
value= this.LoadString(attrValue);
}
return value;
}
this.LoadString= function(id)
{
var str= id;
if (s_t[id] != null)
{
str= s_t[id];
}
return str;
}
this.LS= this.LoadString;
this.LoadParmString= function(id, p1, p2, p3, p4, p5)
{
var parm= new Array();
var message= this.LoadString(id);
if (typeof(p1) != "undefined"){parm[parm.length]=p1;};
if (typeof(p2) != "undefined"){parm[parm.length]=p2;};
if (typeof(p3) != "undefined"){parm[parm.length]=p3;};
if (typeof(p4) != "undefined"){parm[parm.length]=p4;};
if (typeof(p5) != "undefined"){parm[parm.length]=p5;};
for ( var i= 0; i < parm.length; ++i )
{
var expression= "<" + i + "[a-z_A-Z]*>";
var parmTag= new RegExp(expression, "g");
message= message.replace(parmTag, parm[i]);
}
return message;
}
this.LPS= this.LoadParmString;
this.getOperationDisplayName= function(opID, device)
{
var opDisplayName= this.LoadString(opID);
if (typeof(device) != "undefined")
{
var deviceType= device.getAttribute(ATTR_NAME_TYPE);
if( (deviceType== ATTR_VALUE_TYPE_ARRAY_CONTROLLER) && (opID == OPERATION_WRITE_MANAGE_CONTROLLER_PARAMETERS) )
{
opDisplayName= this.LS(STR_LABEL_CONTROLLER_SETTINGS);
}
}
return opDisplayName;
}
this.convertToLabels= function(sUniqueIDList, sOutputDelimiter)
{
if(!sUniqueIDList) return ""; 
var idList= sUniqueIDList.split("&");
sOutputDelimiter= sOutputDelimiter ? sOutputDelimiter : "<BR>";
var lblList= "";
for (var i=0; i < idList.length; ++i)
{
var device= g_model.getDevice(idList[i]); 
if(device)
{
if(lblList=="") lblList+=device.getAttribute(GUI_NAME_LABEL_SHORT);
else lblList += sOutputDelimiter+device.getAttribute(GUI_NAME_LABEL_SHORT); 
}
}   
return lblList;
}
this.getOperationHelpHint= function(opID, device)
{
if (typeof(device) != "undefined")
{
var deviceType= device.getAttribute(ATTR_NAME_TYPE);
if( (deviceType== ATTR_VALUE_TYPE_ARRAY_CONTROLLER) && (opID == OPERATION_WRITE_MANAGE_CONTROLLER_PARAMETERS) )
{
opID= STR_LABEL_CONTROLLER_SETTINGS;
}
}
var opHelpHint= m_hintPresenter.ShowHint(opID);
if (!opHelpHint)
{
opHelpHint= this.getOperationDisplayName(opID);
}
return opHelpHint;
}
this.convert= function(nValue, sFrom, sTo, nPrecision)
{
if(!nPrecision)
{ 
if(sTo==STR_GB) nPrecision= 3;
else if(sTo==STR_TB) nPrecision= 6;
else nPrecision= 0;
}     
sFrom= sFrom.replace(/^\s+/g, '').replace(/\s+$/g, '');
sTo= sTo.replace(/^\s+/g, '').replace(/\s+$/g, '');
var nCurrentVal= toBlocks(nValue, sFrom);
var nConvertedVal= fromBlocks(nCurrentVal, sTo);
var n= Math.pow(10, nPrecision);
nConvertedVal= Math.floor( nConvertedVal*n )/n;
return nConvertedVal;
}
this.convertStr= function(nValue, sFrom, sTo)
{ 
return this.convert(nValue, sFrom, sTo) + " " + g_sp.LS(sTo);
}  
function toBlocks(sValue, sUnits)
{
var sBlocks= sValue;
if ( sUnits== STR_KB ){ sBlocks = MBToBlocks( sValue/m_KB_PER_MB );}
else if( sUnits== STR_MB ){ sBlocks = MBToBlocks( sValue );}
else if( sUnits== STR_GB ){ sBlocks = MBToBlocks( sValue*m_MB_PER_GB );}
else if( sUnits== STR_TB ){ sBlocks = MBToBlocks( sValue*m_MB_PER_TB );}      
return sBlocks;
} 
function fromBlocks(sBlocks, sUnits)
{ 
var sSize= sBlocks;
if ( sUnits== STR_KB ){ sSize = sBlocks/m_BLOCKS_PER_KB;}
else if( sUnits== STR_MB ){ sSize = sBlocks/m_BLOCKS_PER_MB;}
else if( sUnits== STR_GB ){ sSize = sBlocks/m_BLOCKS_PER_GB;}
else if( sUnits== STR_TB ){ sSize = sBlocks/m_BLOCKS_PER_TB;}    
return sSize;
} 
function MBToBlocks(sizeMB)
{
return ((sizeMB * m_BLOCKS_PER_MB) + m_BLOCKS_PER_MB - 1);
}
this.BlocksToMarketingPhysicalSizeStr= function(sizeBlocks)
{
var size;
if ( (sizeBlocks== 644700) ||
(sizeBlocks== 636508)){ size = "330 " + this.LoadString(STR_MB);}
else if ( (sizeBlocks== 1091000) ||
(sizeBlocks== 1082808)){ size = "550 " + this.LoadString(STR_MB);}
else if ( (sizeBlocks== 2051000) ||
(sizeBlocks== 2042808)){ size = "1.05 " + this.LoadString(STR_GB);}
else if (sizeBlocks== 4110000){ size = "2.1 " + this.LoadString(STR_GB);}
else if ( (sizeBlocks== 8386000) ||
(sizeBlocks== 8380080) ||
(sizeBlocks== 8377808) ||
(sizeBlocks== 8371888) ){ size = "4.3 " + this.LoadString(STR_GB);}
else if ( (sizeBlocks== 17765332) ||
(sizeBlocks== 17765308)){ size = "9.1 " + this.LoadString(STR_GB);}
else
{
var totalMBs= (sizeBlocks * m_BYTES_PER_BLOCK)/m_MKT_BYTES_PER_MB;
var GBs= Math.floor((totalMBs) / m_MKT_MB_PER_GB);
var MBs= Math.floor(totalMBs % m_MKT_MB_PER_GB / 100);
size= GBs + "." + MBs + " " + this.LoadString(STR_GB);
if (isNaN(GBs) || isNaN(MBs))
{
size= "??? " + this.LoadString(STR_GB);
}
}
return size;
}
this.intToAlpha= function(value)
{
var alphaCode= parseInt(value) + 65; 
if (alphaCode > 90) 
{
alphaCode= alphaCode + 6;
}
return String.fromCharCode(alphaCode);
}
this.increment= function(value)
{
return parseInt(value) + 1;
}
this.toPercent=function(value, precision)
{
var floatValue= parseFloat(value);
if (!precision)
{
precision= 0;
}
var n= Math.pow(10, precision);
floatValue= Math.floor( floatValue*n )/n;
var percentString= "" + floatValue + "%";
return percentString;
}                  
} 

function CHintPresenter()
{
this.ShowHint= function(sOpName)
{
return o_h[sOpName];
}
var o_h= new Array();
o_h[STR_LABEL_CONTROLLER_SETTINGS]= s_t[STR_OP_HINT_WRITE_MANAGE_CONTROLLER_PARAMETERS];
o_h[STR_MORE_INFO]= s_t[STR_OP_HINT_MORE_INFO];
o_h[STR_VIEW_STATUS_MESSAGES]= s_t[STR_OP_HINT_VIEW_STATUS_MESSAGES];
o_h[GUI_OP_WRITE_ADD_LOGICAL_DRIVE]= s_t[STR_OP_HINT_GUI_OP_WRITE_ADD_LOGICAL_DRIVE];
o_h[GUI_OP_WRITE_MODIFY_LOGICAL_DRIVE]= s_t[STR_OP_HINT_GUI_OP_WRITE_MODIFY_LOGICAL_DRIVE];
o_h[GUI_OP_WRITE_DELETE_LOGICAL_DRIVE]= s_t[STR_OP_HINT_GUI_OP_WRITE_DELETE_LOGICAL_DRIVE];
o_h[GUI_OP_WRITE_MANAGE_SPARE_DRIVES]= s_t[STR_OP_HINT_GUI_OP_WRITE_MANAGE_SPARE_DRIVES];
o_h[GUI_LINK_ADD_CAPACITY_SETTINGS]= s_t[STR_OP_HINT_WRITE_EXPAND_ARRAY];
o_h[GUI_OP_SHRINK_ARRAY]= s_t[STR_OP_HINT_WRITE_SHRINK_ARRAY];
o_h[GUI_OP_MOVE_ARRAY]= s_t[STR_OP_HINT_WRITE_MOVE_ARRAY];
o_h["OPERATION_WRITE_CLEAR_CONFIGURATION"]= s_t[STR_OP_HINT_WRITE_CLEAR_CONFIGURATION];
o_h["OPERATION_WRITE_CREATE_ARRAY"]= s_t[STR_OP_HINT_WRITE_CREATE_ARRAY];
o_h["OPERATION_WRITE_CREATE_LOGICAL_DRIVE"]= s_t[STR_OP_HINT_WRITE_CREATE_LOGICAL_DRIVE];
o_h["OPERATION_WRITE_DELETE_ARRAY"]= s_t[STR_OP_HINT_WRITE_DELETE_ARRAY];
o_h["OPERATION_WRITE_DELETE_LOGICAL_DRIVE"]= s_t[STR_OP_HINT_WRITE_DELETE_LOGICAL_DRIVE];
o_h["OPERATION_WRITE_DISABLE_OTHER_CONTROLLER"]= s_t[STR_OP_HINT_WRITE_DISABLE_OTHER_CONTROLLER];
o_h["OPERATION_WRITE_EXPAND_ARRAY"]= s_t[STR_OP_HINT_WRITE_EXPAND_ARRAY];
o_h["OPERATION_WRITE_EXTEND_LOGICAL_DRIVE"]= s_t[STR_OP_HINT_WRITE_EXTEND_LOGICAL_DRIVE];
o_h["OPERATION_WRITE_MANAGE_ARRAY_ACCELERATOR"]= s_t[STR_OP_HINT_WRITE_MANAGE_ARRAY_ACCELERATOR];
o_h["OPERATION_WRITE_MANAGE_BOX_NAME"]= s_t[STR_OP_HINT_WRITE_MANAGE_BOX_NAME];
o_h["OPERATION_WRITE_MANAGE_CONNECTION_NAME"]= s_t[STR_OP_HINT_WRITE_MANAGE_CONNECTION_NAME];
o_h["OPERATION_WRITE_MANAGE_CONTROLLER_PARAMETERS"]= s_t[STR_OP_HINT_WRITE_MANAGE_CONTROLLER_PARAMETERS];
o_h["OPERATION_WRITE_MANAGE_ADVANCED_CONTROLLER_PARAMETERS"]= s_t[STR_OP_HINT_WRITE_MANAGE_ADVANCED_CONTROLLER_PARAMETERS];
o_h["OPERATION_WRITE_MANAGE_HOST_MODE"]= s_t[STR_OP_HINT_WRITE_MANAGE_HOST_MODE];
o_h["OPERATION_WRITE_MANAGE_SPARE_DRIVE"]= s_t[STR_OP_HINT_WRITE_MANAGE_SPARE_DRIVE];
o_h["OPERATION_WRITE_MANAGE_SSP_ACL"]= s_t[STR_OP_HINT_WRITE_MANAGE_SSP_ACL];
o_h["OPERATION_WRITE_MANAGE_SSP_STATE"]= s_t[STR_OP_HINT_WRITE_MANAGE_SSP_STATE];
o_h["OPERATION_WRITE_MIGRATE_LOGICAL_DRIVE"]= s_t[STR_OP_HINT_WRITE_MIGRATE_LOGICAL_DRIVE];
o_h["OPERATION_WRITE_REENABLE_LOGICAL_DRIVE"]= s_t[STR_OP_HINT_WRITE_REENABLE_LOGICAL_DRIVE];
o_h["OPERATION_WRITE_REENUMERATE"]= s_t[STR_OP_HINT_WRITE_REENUMERATE];
o_h["OPERATION_WRITE_REORDER_LOGICAL_DRIVE"]= s_t[STR_OP_HINT_WRITE_REORDER_LOGICAL_DRIVE];
o_h["OPERATION_WRITE_SET_ASYMMETRICAL_ACTIVE_ACTIVE_SUBMODE"]= s_t[STR_OP_HINT_WRITE_SET_ASYMMETRICAL_ACTIVE_ACTIVE_SUBMODE];
o_h["OPERATION_WRITE_SET_DRIVE_WRITE_CACHE"]= s_t[STR_OP_HINT_WRITE_SET_DRIVE_WRITE_CACHE]; 
o_h["GUI_OP_EXPRESS_CONFIGURATION"]= s_t[STR_OP_HINT_GUI_OP_EXPRESS_CONFIGURATION];
o_h["GUI_LINK_ADVANCED_WIZARDS"]= s_t[STR_OP_HINT_GUI_LINK_ADVANCED_WIZARDS];
o_h["GUI_LINK_PERFORMANCE_SETTING"]= s_t[STR_OP_HINT_GUI_LINK_PERFORMANCE_SETTING];
o_h["GUI_LINK_SSP_SETTINGS"]= s_t[STR_OP_HINT_GUI_LINK_SSP_SETTINGS];
o_h["GUI_LINK_REMOVE_SETTINGS"]= s_t[STR_OP_HINT_GUI_LINK_REMOVE_SETTINGS];
o_h["GUI_LINK_EXPRESS_CREATE_ARRAYS"]= s_t[STR_OP_HINT_GUI_LINK_EXPRESS_CREATE_ARRAYS];
o_h["GUI_LINK_EXPRESS_EXPAND_ARRAYS"]= s_t[STR_OP_HINT_GUI_LINK_EXPRESS_EXPAND_ARRAYS];
o_h["GUI_LINK_EXTEND_LOGICAL_DRIVE"]= s_t[STR_OP_HINT_WRITE_EXTEND_LOGICAL_DRIVE];
o_h["GUI_OP_WRITE_MANAGE_LICENSE_KEYS"]= s_t[STR_OP_HINT_WRITE_MANAGE_LICENSE_KEYS];
o_h["OPERATION_WRITE_ADD_LICENSE_KEY"]= s_t[STR_OP_HINT_WRITE_ADD_LICENSE_KEY];
o_h["OPERATION_WRITE_REMOVE_LICENSE_KEY"]= s_t[STR_OP_HINT_WRITE_REMOVE_LICENSE_KEY];
o_h["OPERATION_WRITE_ERASE_DRIVE"]= s_t[STR_OP_HINT_WRITE_ERASE_DRIVE];
o_h["OPERATION_WRITE_STOP_DRIVE_ERASE"]= s_t[STR_OP_HINT_WRITE_STOP_DRIVE_ERASE];
o_h["OPERATION_WRITE_ENABLE_ERASED_DRIVE"]= s_t[STR_OP_HINT_WRITE_ENABLE_ERASED_DRIVE];
o_h[GUI_OP_VIEW_DIAGNOSTIC_REPORT]= s_t[STR_OP_HINT_GUI_OP_VIEW_DIAGNOSTIC_REPORT];
o_h[GUI_OP_GENERATE_DIAGNOSTIC_REPORT]= s_t[STR_OP_HINT_GUI_OP_GENERATE_DIAGNOSTIC_REPORT];
o_h[GUI_OP_WRITE_MANAGE_HOST_CONTROLLER_ACCESS]= s_t[STR_OP_HINT_GUI_OP_WRITE_MANAGE_HOST_CONTROLLER_ACCESS];
o_h[GUI_OP_WRITE_MANAGE_HOST_CONTROLLER_ACCESS_LOGICAL_DRIVE]= s_t[STR_OP_HINT_GUI_OP_WRITE_MANAGE_HOST_CONTROLLER_ACCESS_LOGICAL_DRIVE];
o_h[GUI_OP_WRITE_ENABLE_SSP]= s_t[STR_OP_HINT_GUI_OP_WRITE_ENABLE_SSP];
o_h[GUI_OP_WRITE_DISABLE_SSP]= s_t[STR_OP_HINT_GUI_OP_WRITE_DISABLE_SSP];
o_h[OPERATION_WRITE_SPLIT_ARRAY]= s_t[STR_OP_HINT_WRITE_SPLIT_ARRAY];
o_h[OPERATION_WRITE_SHRINK_ARRAY]= s_t[STR_OP_HINT_WRITE_SHRINK_ARRAY];
o_h[OPERATION_WRITE_MOVE_ARRAY]= s_t[STR_OP_HINT_WRITE_MOVE_ARRAY];
o_h[OPERATION_WRITE_JOIN_ARRAY]= s_t[STR_OP_HINT_WRITE_JOIN_ARRAY];
}


function filterIcon(iconFileName, iconHeight, iconWidth, iconClass, iconID, imgExtraAttributes){
if(iconClass=== undefined || iconClass == ''){
iconClass= "";
}else if(iconClass != ''){
iconClass= "class='"+iconClass+"'";
}
if (iconID=== undefined || iconID == ''){
iconID= "";
} else if (iconID != ''){
iconID= " id='" + iconID + "'";
}
if (imgExtraAttributes=== undefined || imgExtraAttributes == '')
{
imgExtraAttributes= "";
} else if (imgExtraAttributes != '')
{
imgExtraAttributes= " " + imgExtraAttributes;
}
var imgType= iconFileName.substr(iconFileName.length - 3, 3);
if (g_isMoz || imgType != "png") 
{
var iconHtml= "<img align='absmiddle' "+iconClass+iconID+" style='border:none;height:" + iconHeight + ";width:" + iconWidth + ";' src='"+iconFileName+"'"+imgExtraAttributes+"/>";
}
else
{
var iconHtml= "<!--[if lt IE 7]><img src='images/spacer9.gif' align='absmiddle' " + iconClass + iconID + " style=border:none;height:" + iconHeight + ";width:" + iconWidth + ";filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + iconFileName + "',sizingMethod='scale');" + imgExtraAttributes + " /><![endif]--><!--[if gte IE 7]><img align='absmiddle' " + iconClass + iconID + " style='border:none;' src='" + iconFileName + "'" + imgExtraAttributes + " /><![endif]-->";
}
return iconHtml;
}
function isEven(value)
{
if (value % 2== 0)
{
return true;
}
else
{
return false;
}
} 
function lcm( num1, num2 ) 
{
var w;
var x= num1;
var y= num2;
if ( num1== 0 || num2 == 0 )
{
return 0;
}
while (y != 0)
{
w= x % y;
x= y;
y= w;
}
return ((num1 * num2)/x);
}
function isHeaderAndFooter (opName)
{
return ((opName != OPERATION_WRITE_REENUMERATE) &&
(opName != OPERATION_WRITE_CLEAR_CONFIGURATION) &&
(opName != OPERATION_WRITE_DELETE_ARRAY) &&
(opName != OPERATION_WRITE_DELETE_LOGICAL_DRIVE) &&
(opName != OPERATION_WRITE_ENABLE_ERASED_DRIVE) &&
(opName != OPERATION_WRITE_DISABLE_OTHER_CONTROLLER) &&
(opName != OPERATION_WRITE_REENABLE_LOGICAL_DRIVE) &&
(opName != OPERATION_WRITE_STOP_DRIVE_ERASE) &&
(opName != GUI_OP_WIZARD_HOME) &&
(opName != OPERATION_WRITE_SPLIT_ARRAY));
}                             
function xShowHeader(sID)
{
if(sID)
{
var m_Element= document.getElementById(sID); 
var m_headerElement= document.getElementById(sID + "_HEADER");
var m_headerElement1= document.getElementById(sID + "_HEADER_1");
if (m_headerElement)
{
m_headerElement.style.display= "block";
}    
if (m_headerElement1)
{
m_headerElement1.style.display= "block";
}
if (m_Element)
{
m_Element.style.borderTopWidth= "0px";
}
CResizeCtrl.handleResize();
}
}
function xHideHeader (sID)
{
if(sID)
{
var m_Element= document.getElementById(sID); 
var m_headerElement= document.getElementById(sID + "_HEADER");
var m_headerElement1= document.getElementById(sID + "_HEADER_1");
if (m_headerElement)
{
m_headerElement.style.display= "none";
}   
if (m_headerElement1)
{
m_headerElement1.style.display= "none";
}
if (m_Element)
{
m_Element.style.borderTopWidth= "3px";
m_Element.style.borderTopColor= "#CCCCCC";
}
CResizeCtrl.handleResize();
}
}
function hideTaskFooter(sID)
{
if (sID)
{
var m_Element= document.getElementById(sID); 
var m_footerElement= document.getElementById(sID + "_FOOTER");
if(m_footerElement)
{
m_footerElement.style.display= "none";
}
CResizeCtrl.handleResize();
}
}
function showTaskFooter (sID)
{
if (sID)
{
var m_Element= document.getElementById(sID); 
var m_footerElement= document.getElementById(sID + "_FOOTER");
if(m_footerElement)
{
m_footerElement.style.display= "block";
}
CResizeCtrl.handleResize();
}
}
function DisplayMessage(sMsg, sID)
{
if(document.getElementById(sID))
{
document.getElementById(sID).innerHTML= "<DIV id=ProcessingAreaID class='LoadingArea'><SPAN ID=SavingMsg>" + sMsg + "</SPAN><BR/><IMG SRC='images/progress_bar_large.gif'/></DIV>";
}
}
function isSSPController(device)
{
return device.getAttribute(ATTR_NAME_TYPE) == ATTR_VALUE_TYPE_STORAGE_SYSTEM;
}
function getSelectedController()
{
if (typeof (g_dropDown) != "undefined")
{
return g_dropDown.getCurrentSelectedValue();
}
else
{
return false;
}
}
function getSelectedTab()
{
return (new CUserPreferences()).GetValue("TAB_ID", "");
}
function msieversion()
{
var ua= window.navigator.userAgent;
var msie= ua.indexOf("MSIE ");
if (msie > 0) 
{
return parseInt(ua.substring(msie + 5, ua.indexOf(".", msie)));
}
else 
{
return 0;
}
}
function getTreeDeviceIcon(device)
{
var sIconHtml= '';
var sStateOverlay;
if (typeof (device) == "object")
{
var sIcon= device.getAttribute(GUI_NAME_ICON_SMALL);
var sOverlay= "";
var sStateOverlay= device.getAttribute("GUI_NAME_OVERLAY_ICON_SMALL");
var sStatusType= device.getAttribute("GUI_NAME_STATUS_TYPE");
var sStatusValue= device.getAttribute(ATTR_NAME_STATUS);
if (sStatusType != "GUI_VALUE_STATUS_TYPE_OK")
{
sOverlay= device.getAttribute("GUI_NAME_STATUS_ICON_SMALL");
}
sIconHtml= filterIcon(sIcon, '20px', '20px');
if (sStateOverlay)
{
sIconHtml += filterIcon(sStateOverlay, '12px', '12px', 'overlay');
if (sOverlay)
{
sIconHtml += filterIcon(sOverlay, '12px', '12px', 'overlayLeft');
}
}
else if (sOverlay)
{
sIconHtml += filterIcon(sOverlay, '12px', '12px', 'overlay');
}
}
else if(device != '')
{
sIconHtml= filterIcon(device, '20px', '20px');
}
return '<span style="margin-right:6px;">' + sIconHtml + '</span>';
}
function drawNote(sNote)
{
return "<TABLE style=\"margin-left:5px;\"><TR><TD valign=\"top\">" + filterIcon("images/infostat20.png", 20, 20) + "</TD><TD class=\"InfoNote\">" + g_sp.LS(STR_NOTE) + g_sp.LS(sNote) + "</TD></TR></TABLE>";
}
function isInTask()
{
var session= new CSessionData();
return (session.GetData("task_state", "task_in_progress")) || (session.GetData("wizard_state", "wizard_in_progress"));
}
function ldPred(lhs, rhs)
{
return parseInt(lhs.getAttribute(ATTR_NAME_DRIVE_NUMBER)) - parseInt(rhs.getAttribute(ATTR_NAME_DRIVE_NUMBER));
}
